window.desk = {
	init: function() {
		//alert("go");
		desk.start();
		common.handle_external_links();
	},
	start: function(version) {

		var url = localStorage.server + "/api/method/frappe.www.desk.get_desk_assets_dbg";
		// if(version && version === "v6") {
		// 	url = localStorage.server + "/api/method/frappe.templates.pages.desk.get_desk_assets_dbg";
		// }

		$.ajax({
			method: "GET",
			url: url,
			data: {
				build_version: localStorage._build_version || "000"
			}
		}).success(function(data) {
			// desk startup
			window._version_number = data.message.build_version;
			window.app = true;
			if(!window.frappe) { window.frappe = {}; }
			window.frappe.list_desktop = cordova.platformId==="ios";
			window.frappe.boot = data.message.boot;
			window.dev_server = data.message.boot.developer_mode;

// 			if(cordova.platformId === "ios") {
// 				document.addEventListener("deviceready", function() {
// 					StatusBar.backgroundColorByHexString("#f5f7fa");
// 				});
// 			}

// 			// if(cordova.platformId === "android") {
// 			// 	document.addEventListener("deviceready", function() {
// 			// 		StatusBar.backgroundColorByHexString("#f5f7fa");
// 			// 	});
// 			// }
// 				// alert(data.message.build_version)
// 				// alert(localStorage._build_version)
// 			if(localStorage._build_version != data.message.build_version) {
// 				localStorage._build_version = data.message.build_version;
// 				common.write_file("assets.txt", JSON.stringify(data.message.assets));
// 				// alert(1)
// 				// var new_assets = JSON.stringify(data.message.assets);
// 				// alert(new_assets.length);
// 				desk.desk_assets = data.message.assets;
// 			}
// // common.read_file("js/server/mcontrol.min.js", function (assets) {
// //     alert(20);
// //     alert(assets);
// //     // alert(assets.length);
// //     desk.desk_assets = JSON.parse(assets);
// //     desk.setup_assets();
// // });
// 			if(!desk.desk_assets) {
// 				common.read_file("assets.txt", function (assets) {
// 					// alert(2)
// 					// alert(assets.length);
// 					desk.desk_assets = JSON.parse(assets);
// 					desk.setup_assets();
// 				});
// 			}
// 			else {
// 				desk.setup_assets();
// 			}
		desk.setup_assets();
		}).error(function(e) {
			if(![403, 401].includes(parseInt(e.status))) {
				// alert(`${localStorage.server} failed with status ${e.status}`);
				alert(`系统正在维护，请稍后登陆。`);
			}
			desk.logout();
		});
	},
	setup_assets1: function() {
		// for(key in desk.desk_assets) {
		// 	var asset = desk.desk_assets[key];
		// 	if(asset.type == "js") {
		// 		common.load_script(asset.data);
		// 	} else {
		// 		var css = asset.data.replace(/url['"\(]+([^'"\)]+)['"\)]+/g, function(match, p1) {
		// 			var fixed = (p1.substr(0, 1)==="/") ? (localStorage.server + p1) : (localStorage.server + "/" + p1);
		// 		});
		// 		common.load_style(css);
		// 	}
		// }
		// start app
		// patch urls

		frappe.request.url = localStorage.server + "/";
		frappe.base_url = localStorage.server;
		common.base_url = localStorage.server;

		// render the desk
		frappe.start_mobile_app();

		// override logout
        frappe.app.redirect_to_login = function() {
			localStorage.removeItem('session_id');
			window.location = "index.html";
		}
		// app user relogin
		frappe.app.apprelogin = function(url) {
			window.location = "index2.html";
		}

		frappe.app.goback = function() {
		    if (frappe.get_route_str() == "List/Course Schedule/Calendar/Default") {  
				frappe.set_route("mobile_mine");
		    } else {
		        window.history.back(-1);
		    }
		    return false;
		}

	},
	logout: function() {
		localStorage.removeItem('session_id');
		window.location = "index.html";
	},

	load_script : function(url, callback) {
	   var head = document.getElementsByTagName('head')[0];
	   var script = document.createElement('script');
	   script.type = 'text/javascript';
	   script.src = url;

	   script.onreadystatechange = callback;
	   script.onload = callback;

	   head.appendChild(script);
	},
	js_chain : function(){
		desk.load_script("js/server/mlibs.min.js", function() {
			desk.load_script("js/server/mdesk.min.js",function() {
				desk.load_script("js/server/mlist.min.js",function() {
					desk.load_script("js/server/mform.min.js",function() {
						desk.load_script("js/server/mcontrol.min.js",function() {
							desk.load_script("js/server/mreport.min.js",function() {
								desk.load_script("js/server/toolbar.js", desk.after_chain);		
							});			
						});		
					});			
				});		
			});
		});
	},

	after_chain: function() {
		// start app
		// patch urls
		frappe.request.url = localStorage.server + "/";
		frappe.base_url = localStorage.server;
		common.base_url = localStorage.server;

		// render the desk
		frappe.start_mobile_app();

		// override logout
        frappe.app.redirect_to_login = function() {
			localStorage.removeItem('session_id');
			window.location = "index.html";
		}
		// app user relogin
		frappe.app.apprelogin = function(url) {
			window.location = "index2.html";
		}

		frappe.app.goback = function() {
		    if (frappe.get_route_str() == "List/Course Schedule/Calendar/Default") {  
				frappe.set_route("mobile_tab4");
		    } else {
		        window.history.back(-1);
		    }
		    return false;
		}
	},

	setup_assets: function() {
		desk.js_chain();
			
	}
}

// $(window).load(function(){desk.init();});
$(document).ready(function() { desk.init(); });

document.addEventListener("backbutton",eventBackButton, false);

function eventBackButton(){
    var url = window.location.href;
    var param = url.split("#");

	function QuitCallback(buttonIndex){
		if(buttonIndex == 2){
			navigator.app.exitApp();
		}
	}

    if(param.length == 2){
        var p1 = param[1];
        if(p1 == "prop_manage") {
        	if($("#prop_header_back").css("display")=="none"){
	            //隐藏的
            	frappe.app.goback();
	        }else{
	            //显示的
            	scanCancel();
	        }
        } else if(in_list(["mobile_home", "mobile_tab1", "mobile_tab2", "mobile_tab3",
            "mobile_tab4"], p1)) {
			// navigator.app.exitApp();
			// //制作一个提示窗口 确认是否退出
			var message = "您是否要退出东营老干部吗？";
			var title = "提示";
			var buttonLabels = "取消,退出";
			navigator.notification.confirm(message, QuitCallback, title, buttonLabels);
        } else {
            frappe.app.goback();
        }
    } else {
		navigator.app.exitApp();
		// //制作一个提示窗口 确认是否退出
		// var message = "您是否要退出东营老干部吗？";
		// var title = "退出提示";
		// var buttonLabels = "取消,退出";
		// navigator.notification.confirm(message, QuitCallback, title, buttonLabels);
    }
}